#pragma once

#include <string>

#include "response.h"

namespace scene {
extern void asyncResponse(const std::string& taskId, const Response& response);
extern void asyncFlowResponse(const std::string& taskId, const Response& response, bool end);
}  // namespace scene

/**
 * 异步返回：
 * 结果成功或失败都调用 ASYNC_RESPONSE
 */
#define ASYNC_RESPONSE(taskId, response) scene::asyncResponse(taskId, response)

/**
 * 异步流式返回：
 * 每阶段处理成功调用 ASYNC_FLOW_RESPONSE_CONTINUE
 * 最后处理完成调用 ASYNC_FLOW_RESPONSE_END
 * 每阶段处理失败调用 ASYNC_FLOW_RESPONSE_END
 */
#define ASYNC_FLOW_RESPONSE(taskId, response, end) scene::asyncFlowResponse(taskId, response, end)
#define ASYNC_FLOW_RESPONSE_CONTINUE(taskId, response) ASYNC_FLOW_RESPONSE(taskId, response, false)
#define ASYNC_FLOW_RESPONSE_END(taskId, response) ASYNC_FLOW_RESPONSE(taskId, response, true)
